upload_mega.sh 8.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308
  1. #!/bin/bash
  2. set -e
  3. version=5.5
  4. date=26/12/2022
  5. pi7z_i=""
  6. swap_was="0"
  7. ftp_i=0
  8. pv_i=0
  9. cifs_i=0
  10. retry_flag=0
  11. daemon_on=0
  12. split_size=200
  13. OSV=$(sed 's/\..*//' /etc/debian_version)
  14. DietPi_="NO"
  15. if [ $OSV = 8 ];then img_v="Jessie";fi
  16. if [ $OSV = 9 ];then img_v="Strecth"; fi
  17. if [ $OSV = 10 ];then img_v="Buster"; fi
  18. if [ $OSV = 11 ];then img_v="Bullseye"; fi
  19. echo -e "$(tput setaf 5)"
  20. echo -e " ╔╗ ╔═╗╔═╗╔╦╗╔═╗╔╦╗╦═╗╔═╗╔═╗"
  21. echo -e " ╠╩╗║ ║║ ║ ║ ╚═╗ ║ ╠╦╝╠═╣╠═╝"
  22. echo -e " ╚═╝╚═╝╚═╝ ╩ ╚═╝ ╩ ╩╚═╩ ╩╩ "
  23. echo -e " ╔╗ ╦ ╦╦╦ ╔╦╗╔═╗╦═╗ "
  24. echo -e " ╠╩╗║ ║║║ ║║║╣ ╠╦╝ "
  25. echo -e " ╚═╝╚═╝╩╩═╝═╩╝╚═╝╩╚═ "
  26. echo -e ""
  27. echo -e "\e[97mOkcash Blockchain Uploader v$version ($date)\e[0m"
  28. echo -e "Author : wareck@gmail.com"
  29. echo -e ""
  30. echo -e "Raspbian : $img_v"
  31. echo -e "Upload : Mega.nz"
  32. echo -e "Format : 7z"
  33. echo -e "Packet Size : $split_size Mo"
  34. echo -e ""
  35. sleep 4
  36. function init {
  37. if ps -ef | grep -v grep | grep okcashd >/dev/null
  38. then
  39. daemon_on=1
  40. echo -e "\n\e[93mStopping Okcashd :\e[0m"
  41. okcashd stop 2>/dev/null || true && sudo /etc/init.d/cron stop 2>/dev/null || true
  42. sleep 2
  43. if ps -ef | grep -v grep | grep okcashd >/dev/null ; then killall -9 okcashd; fi
  44. sleep 2
  45. if [ -f /usr/local/bin/okcashd ];then sudo mv /usr/local/bin/okcashd /usr/local/bin/okcashd_old |true ;fi
  46. if ps -ef | grep -v grep | grep okcashd >/dev/null ; then killall -9 okcashd; fi
  47. echo "Done."
  48. fi
  49. if [ "`systemctl is-active watchdog.service`" = "active" ]
  50. then
  51. echo -e "\n\e[93mStopping watchdog :\e[0m"
  52. sudo systemctl stop watchdog >/dev/null
  53. echo "Done."
  54. fi
  55. if [ -d /home/$USER/scripts/ledstatus/ ]
  56. then
  57. case $OSV in
  58. 11)
  59. sudo python3 /home/$USER/scripts/ledstatus/led_off.py ;;
  60. *)
  61. sudo python /home/$USER/scripts/ledstatus/led_off.py ;;
  62. esac
  63. fi
  64. if [ -f /var/swap ]
  65. then
  66. echo -e "\n\e[93mStopping Swap :\e[0m"
  67. sudo dphys-swapfile swapoff /var/swap
  68. sudo rm /var/swap
  69. swap_was="1"
  70. echo "Done."
  71. fi
  72. }
  73. function check_software_ {
  74. echo -e "\n\e[95mChecking Softwares :\e[0m"
  75. echo -e -n "Check PI7Z installed : "
  76. if ! [ -x "$(command -v 7z)" ]; then pi7z_i="p7zip-full" && echo -e "[\e[91m NO \e[0m]"; else pi7z_i="" && echo -e "[\e[92m YES \e[0m]"; fi
  77. echo -e -n "Check LFTP installed : "
  78. if ! [ -x "$(command -v lftp)" ]; then ftp_i="lftp" && echo -e "[\e[91m NO \e[0m]"; else ftp_i="" && echo -e "[\e[92m YES \e[0m]"; fi
  79. echo -e -n "Check CIFS installed : "
  80. if ! [ -x "$(command -v cifscreds)" ]; then cifs_i="cifs-utils" && echo -e "[\e[91m NO \e[0m]"; else cifs_i="" && echo -e "[\e[92m YES \e[0m]"; fi
  81. echo -e -n "Check PV installed : "
  82. if ! [ -x "$(command -v pv)" ]; then pv_i="pv" && echo -e "[\e[91m NO \e[0m]"; else pv_i="" && echo -e "[\e[92m YES \e[0m]"; fi
  83. if [[ ! $ftp_i = "" || ! $pi7z_i = "" || ! $pv_i = "" || ! $cifs_i = "" ]]
  84. then
  85. echo -e "\n\e[95mSoftwares update & install :\e[0m"
  86. sudo apt-get update
  87. sudo apt install $pi7z_i $ftp_i $pv_i $cifs_i cifs-utils -y
  88. check_software_
  89. fi
  90. echo -e "Done."
  91. }
  92. function freeze_on {
  93. NEW_FAN=5.0
  94. if [ -f /home/$USER/scripts/run-fan.py ]
  95. then
  96. echo -e "\n\e[95mEnable \e[38;5;196mF\e[38;5;202mr\e[38;5;208me\e[38;5;214me\e[38;5;220mz\e[38;5;226mi\e[38;5;227mn\e[38;5;229mg\e[0m \e[95m:\e[0m"
  97. sudo systemctl stop run-fan.service
  98. if ! [ -f /home/$USER/freeze.txt ]
  99. then
  100. if grep "# Author: Andreas Spiess" /home/$USER/scripts/run-fan.py >/dev/null
  101. then
  102. grep -i "desiredTemp = " /home/$USER/scripts/run-fan.py |awk 'NR==1 {print$3;exit}' >/home/$USER/freeze.txt
  103. else
  104. grep -i "self.startTemperature = " /home/$USER/scripts/run-fan.py |awk 'NR==1 {print$3;exit}' >/home/$USER/freeze.txt
  105. fi
  106. fi
  107. OLD_FAN=`cat /home/$USER/freeze.txt| awk '{print $1}'`
  108. echo "Fan PWM value : $OLD_FAN => $NEW_FAN"
  109. if grep "# Author: Andreas Spiess" ~/scripts/run-fan.py >/dev/null
  110. then
  111. sed -i -e "s/desiredTemp = "$OLD_FAN"/desiredTemp = "$NEW_FAN"/g" /home/$USER/scripts/run-fan.py
  112. else
  113. sed -i -e "s/self.startTemperature = "$OLD_FAN"/self.startTemperature = "$NEW_FAN"/g" /home/$USER/scripts/run-fan.py
  114. fi
  115. sudo systemctl restart run-fan.service
  116. echo -e "Done."
  117. sleep 1
  118. fi
  119. }
  120. function freeze_off {
  121. echo -e -n ""
  122. if [ -f /home/$USER/scripts/run-fan.py ]
  123. then
  124. echo -e "\n\e[95mDisable Freezing :\e[0m"
  125. OLD_FAN=`cat /home/$USER/freeze.txt| awk '{print $1}'`
  126. if grep "# Author: Andreas Spiess" ~/scripts/run-fan.py >/dev/null
  127. then
  128. echo "Fan PWM value : $NEW_FAN => $OLD_FAN"
  129. else
  130. echo "Fan value: $NEW_FAN =>$OLD_FAN"
  131. fi
  132. sudo systemctl stop run-fan.service
  133. if grep "# Author: Andreas Spiess" ~/scripts/run-fan.py >/dev/null
  134. then
  135. sed -i -e "s/desiredTemp = "$NEW_FAN"/desiredTemp = "$OLD_FAN"/g" /home/$USER/scripts/run-fan.py
  136. else
  137. sed -i -e "s/self.startTemperature = "$NEW_FAN"/self.startTemperature = "$OLD_FAN"/g" /home/$USER/scripts/run-fan.py
  138. fi
  139. sudo systemctl restart run-fan.service
  140. if [ -f /home/$USER/freeze.txt ];then rm /home/$USER/freeze.txt;fi
  141. echo -e "Done."
  142. fi
  143. }
  144. function packit {
  145. echo -e "\n\e[95mPacking & Compressing Files :\e[0m"
  146. cd /home/$USER
  147. echo -e "\e[97mCompress & split bootstrap.7z:\e[0m"
  148. split_size="${split_size}m"
  149. 7z a -m0=lzma -mx9 -mfb=64 -md32m -v$split_size bootstrap .okcash/blk0001.dat .okcash/txleveldb/
  150. sleep 1
  151. echo "Done."
  152. echo -e "\n\e[95mMake bootstrap_v.txt:\e[0m"
  153. if [ -f bootstrap_v.txt ]; then rm bootstrap_v.txt;fi
  154. Raw_date="`date +%d.%m.%Y`"
  155. YYYY=`ls -l bootstrap*.0* | wc -l`
  156. cat <<'EOF'>> bootstrap_v.txt
  157. Bootstrap : XXXX
  158. Parts: YYYY
  159. Size : ZZZZ Mo
  160. Links:
  161. EOF
  162. sed -i -e "s/XXXX/$Raw_date/g" bootstrap_v.txt
  163. sed -i -e "s/YYYY/$YYYY/g" bootstrap_v.txt
  164. split_size="${split_size%?}"
  165. sed -i -e "s/ZZZZ/$split_size/g" bootstrap_v.txt
  166. echo "Done."
  167. echo -e "\n\e[95mMd5sum Files:\e[0m"
  168. zap=$(ls -l bootstrap.7z.* | wc -l)
  169. for i in `seq -w 001 $zap`
  170. do
  171. echo -e -n "md5sum Bootstrap.7z.$i: " && md5sum bootstrap.7z.$i > bootstrap.$i.md5 && echo -e "\e[1mDone.\e[0m"
  172. done
  173. touch /home/$USER/bootstrap_uploadpass
  174. }
  175. function ftp_check {
  176. FTP_SUCCESS_MSG="226 Transfer complete"
  177. if fgrep "$FTP_SUCCESS_MSG" $Ftp_LOG ;then
  178. echo "ftp transfer : OK"
  179. echo ""
  180. rm $Ftp_LOG
  181. else
  182. echo "ftp transfer Error: $ftp_file"
  183. rm $Ftp_LOG
  184. echo ""
  185. ftp_loop
  186. fi
  187. }
  188. function ftp_loop {
  189. lftp -u wareck,zorn692611 ftpperso.free.fr <<EOF
  190. put $ftp_file -o /crypto/okcash/bootstrap/$ftp_file
  191. EOF
  192. echo -n $ftp_file && echo -e ": \e[1mDone.\e[0m";
  193. }
  194. function upload {
  195. cd /home/$USER
  196. echo -e "\n\e[95mUpload files to FTP server :\e[0m"
  197. ftp_file=bootstrap_v.txt && ftp_loop
  198. zap=$(ls -l bootstrap.7z.0* | wc -l)
  199. for j in `seq -w 001 $zap`
  200. do
  201. ftp_file=bootstrap.$j.md5
  202. ftp_loop
  203. done
  204. echo -e "\n\e[95mUpload files to Freebox :\e[0m"
  205. if ! [ -d /tmp/bootstrap ]; then mkdir /tmp/bootstrap ;fi
  206. if mount | grep -i "//mafreebox.freebox.fr/" >/dev/null
  207. then
  208. sudo umount /tmp/bootstrap/
  209. fi
  210. sudo mount -t cifs //mafreebox.freebox.fr/Disque\ dur/ /tmp/bootstrap/ -o user=freebox,password=password,uid=1000,gid=1000,rw,vers=1.0
  211. if ! [ -d /tmp/bootstrap/bootstrap ]; then mkdir /tmp/bootstrap/bootstrap ;fi
  212. cp -v bootstrap.7z.* /tmp/bootstrap/bootstrap/
  213. cp -v bootstrap_v.txt /tmp/bootstrap/bootstrap/
  214. cp -v bootstrap.*.md5 /tmp/bootstrap/bootstrap/
  215. if [ -f bootstrap_okcash ]
  216. then
  217. rm -r bootstrap_okcash
  218. fi
  219. sleep 5
  220. sudo umount /tmp/bootstrap
  221. freeze_off
  222. echo -e "\n\e[92mUpload Done ...\n\e[0m"
  223. }
  224. function end_restart {
  225. if [ -f /usr/local/bin/okcashd_old ]
  226. then
  227. sudo mv /usr/local/bin/okcashd_old /usr/local/bin/okcashd | true
  228. okcashd
  229. fi
  230. }
  231. function retry {
  232. if [ -f /home/$USER/bootstrap_uploadpass ]; then retry_flag=1 ;fi
  233. if [ $retry_flag = "1" ]
  234. then
  235. echo -e "\n\e[95mRetry Upload to server :\e[0m"
  236. echo -e "Old files are still present."
  237. echo -e "If you want to force restart build/upload"
  238. echo -e "remove files by using this command:"
  239. echo -e ""
  240. echo -e "rm -r -f /home/$USER/bootstrap.7z.* /home/$USER/bootstrap_v.txt /home/$USER/bootstrap.7z.*.md5 /home/$USER/bootstrap_uploadpass"
  241. sleep 5
  242. fi
  243. }
  244. if ps -ef | grep -v grep | grep okcashd >/dev/null
  245. then
  246. echo -e "\n\e[38;5;166mOKcash daemon is working => shutdown and restart during this process !...\e[0m"
  247. while true; do
  248. read -p "Do you want to start processing (y/n) ? " yn
  249. case $yn in
  250. [Yy]* ) init ; check_software_; freeze_on ; retry ; packit ; upload ; end_restart ; break;;
  251. [Nn]* ) exit;;
  252. * ) echo "Please answer yes or no.";;
  253. esac
  254. done
  255. else
  256. init
  257. check_software_
  258. freeze_on
  259. retry
  260. if [ $retry_flag = "1" ]
  261. then
  262. upload
  263. end_restart
  264. else
  265. packit
  266. upload
  267. end_restart
  268. fi
  269. fi
  270. if [ swap_was = 1 ]
  271. then
  272. echo -e "\n\e[95mRestart Swap:\e[0m"
  273. sudo dphys-swapfile setup
  274. sudo dphys-swapfile swapon
  275. echo "Done."
  276. fi
  277. if [ -f /home/$USER/bootstrap_uploadpass ]; then rm /home/$USER/bootstrap_uploadpass;fi
  278. if [ $daemon_on = 1 ]
  279. then
  280. echo -e "\n\e[38;5;166mOKcash daemon is restarting ...\e[0m"
  281. if [ -f /usr/local/bin/okcashd_old ]
  282. then
  283. sudo mv /usr/local/bin/okcashd_old /usr/local/bin/okcashd | true
  284. fi
  285. fi
  286. echo ""